<?php
// Este archivo es importante ya que
// Define nuestra interface para comunicarnos
// con los modulos
include("Formateador.interface.php");

function formatear($texto,$modulo) {
  // Revisamos si el modulo especificado 
  // existe
  if(is_file($modulo.".class.php")) {
    // Cargamos el archivo del modulo
    require_once($modulo.".class.php");

    // Revisamos que se pueda crear un
    // objeto con el nombre de clase dado
    if(!class_exists($modulo)) {
      return "El archivo $modulo.class.php existe, pero no hay ninguna clase de nombre $modulo";
    }

    //Creamos una nueva instancia del modulo
    $formateador = new $modulo();

    // Revisamos si el modulo es una instancia
    // de un Formateador
    if($formateador instanceof Formateador) {
      // Llamamos a la funcion de formateo de
      // texto del modulo
      return $formateador->formatear($texto);
    } else {
      return "El modulo $modulo, no es una instancia de Formateador";
    }
  } else {
    return "El modulo no pudo ser cargado";
  }
}

?>
<html>
<head><title>Prueba de M&oacute;dulos</title></head>
<body>
<p>Este es un archivo de prueba de modulos</p>

<p><?php echo formatear("Modulo Negrita","Negrita") ?></p>
<p><?php echo formatear("Modulo Cursiva","Cursiva") ?></p>
<p><?php echo formatear("Modulo Subrayado","Subrayado") ?></p>
<p><?php echo formatear("Modulo no existente","Dummy") ?></p>
<p><?php echo formatear("Modulo no valido","Novalido") ?></p>
<p><?php echo formatear("Modulo no valido","NoClase") ?></p>

</body>
</html>
